//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * アンズ走り状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Player/Anzu/AnzuRunState.h"
#include "Game/Sound/SoundSystem.h"
#include "Player/System/Player.h"
#include "Stage/System/Stage.h"

#include "Player/Anzu/AnzuStandState.h"
#include "Player/Anzu/AnzuJumpState.h"
#include "Player/Anzu/AnzuAttackState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
AnzuRunState::AnzuRunState(Anzu* anzu) : AnzuState(anzu){
}
//------------------------------------------------------------------------------
// デストラクタ
AnzuRunState::~AnzuRunState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void AnzuRunState::initialize(){
	// アニメーションシーケンス設定
	getAnimation()->setSequence(1);
	// 足音カウンタ初期化
	footstepCounter_ = 20.f;
}
//------------------------------------------------------------------------------
// 後始末
void AnzuRunState::finalize(){
}
//------------------------------------------------------------------------------
// 実行
void AnzuRunState::run(){
	Assert(!isAerial());
	// 定数
	float animationScale = 4.f;
	float moveXZScale = 0.5f;

	// ステート変更
	Point2f moveStick = getMoveStick();
	Vector3 moveVelocity(moveStick.x, 0.f, moveStick.y);
	if(!isDamaged()){
		if(downAttackButton()){
			getPlayer()->setState(new AnzuAttackState(getAnzu()));
		}else if(downJumpButton()){
			getPlayer()->setState(new AnzuJumpState(getAnzu(), false));
		}else if(moveVelocity.isZero()){
			getPlayer()->setState(new AnzuStandState(getAnzu()));
		}
	}

	// 移動ベクトル算出
	moveVelocity *= moveXZScale;

	// アニメーション速度調整
	animationScale *= moveVelocity.getLength();

	// 足音を鳴らす
	footstepCounter_ += animationScale;
	if(footstepCounter_ > 30.f){
		getSoundSystem()->play("AnzuAsioto", 0.5f);
		footstepCounter_ = 0.f;
	}

	// 位置と速度の計算
	calcVelocityAndPosition(moveVelocity);
	// 向きの設定
	setDirection(moveVelocity);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);
}
//------------------------------------------------------------------------------
